# include "std.h"
# if LICENCE
   This file is part of cwrite.
   Copyright 2007, Desislav Georgiev.
 
   cwrite is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
 
   cwrite is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with cwrite.  If not, see <http://www.gnu.org/licenses/>.
# endif
# if HEADER
   # include <stdlib.h>

   # include "block.h"
   # include "block_c.h"
   # include "cwrite.h"
   # include "preferences.h"
   # include "status_line.h"
# endif

int block_locate(Datachain * _datachain_block_header, Datachain ** __datachain_block_begin, Datachain ** __datachain_block_end)
   { int block_level;

     switch (_preferences->syntax)
        { case SYNTAX_NONE:
             return BLOCK_NO_SYNTAX;
          case SYNTAX_C:
             block_level = block_locate_c_preprocessor(_datachain_block_header, __datachain_block_begin, __datachain_block_end);
             //status_line_vprintf("%d ", block_level);
             if ( block_level > 0 )
                { return block_level;
                }
             block_level = block_locate_c_common(_datachain_block_header, __datachain_block_begin, __datachain_block_end);
             //status_line_vprintf("%d %x %x", block_level, * __datachain_block_begin, * __datachain_block_end);
             break;
        }
     return block_level;
   }
