# include "std.h"
# if LICENCE
   This file is part of cwrite.
   Copyright 2007, Desislav Georgiev.
 
   cwrite is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
 
   cwrite is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with cwrite.  If not, see <http://www.gnu.org/licenses/>.
# endif
# if HEADER
   # include <stdlib.h>

   # include "color_theme.h"
   # include "cursor.h"
   # include "cwrite.h"
   # include "datasystem.h"
   # include "message.h"
   # include "mycurses.h"
   # include "screen.h"
   # include "string.h"
# endif
# if GLOBAL
   char * _header_line;
# endif

void header_line_init()
   { _header_line = (char *) malloc(screen_cols);
     _memset(_header_line, ' ', screen_cols);

      return;
   }
void header_line_greet()
   { char * _header_line_point = _header_line;
     int name_len = string_len(_message[2]);

     line_copy(_header_line, _message[1]);
     _header_line_point = _header_line + screen_cols - name_len - 1;
     line_copy(_header_line_point, _message[2]);
     return;
   }

void header_line_clear()
   { _memset(_header_line, ' ', screen_cols);

      return;
   }
void header_line_form()
   { char * _header_line_point = _header_line + 2;

     * _header_line_point++ = '-';
     * _header_line_point++ = datasystem_ordinal + 48;
     * _header_line_point++ = '-';
     * _header_line_point++ = ' ';
     int m = (screen_cols - string_len(_datasystem->_filename))/2;
     //_header_line_point += m;
     _header_line_point = _header_line + m;
     line_copy(_header_line_point, _datasystem->_filename);

     return;
   }

void header_line_redraw()
   { curses_mvaddnstr(HEADER_LINE, 0, _header_line, screen_cols);
     curses_mvchgat(HEADER_LINE, 0, screen_cols, A_NORMAL, header_color_pair, 0);
     curses_touchline(stdscr, HEADER_LINE, 1);
     cursor_move(* _cursor_y, * _cursor_x);

     return;
   }
void header_line_refresh()
   { header_line_clear();

     if ( ! datasystem_count )
        { header_line_greet();
        }
     else
        { header_line_form();
        }
     header_line_redraw();

     return;
   }
